; -----------------------------------------------------------------------------
;	蔻菈
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"
		.include	"bgmdriver_h.asm"

		.area	CODE (ABS)
		.globl	player_info
		.globl	enemy_info0
		.globl	enemy_info1
		.globl	enemy_info2
		.globl	enemy_info3
		.globl	enemy_info4
		.globl	enemy_info5
		.globl	shot_info0
		.globl	shot_info1
		.globl	shot_info2
		.globl	eshot_info
		.globl	score_update
		.globl	score_add
		.globl	top_score_check
		.globl	enemy_bomb
		.globl	enemy_boss_destroy_request
		.globl	goto_gameover
		.globl	player_shield
		.globl	player_invincibility
		.globl	player_speed_up
		.globl	player_shot_power_up
		.globl	background_update_player_info
		.globl	background_get_char
		.globl	background_get_fore_char
		.globl	background_put_char
		.globl	draw_boss8_delete
		.globl	draw_boss8_center_delete
		.globl	random

; -----------------------------------------------------------------------------
;	@蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: GGeɏՓ˂Ă
;	break
;		a, f, b, d, e, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_player_clash::
		; GԂH
		ld		a, (player_invincibility)
		or		a
		ret		nz
		; 蔻
		call	check_player_clash_sub				; GE{XƂ̂蔻
		jp		c, check_player_clash_skip1
		call	check_player_clash_sub2				; X{XƂ̂蔻
		ret		nc
check_player_clash_skip1:
		; _[Wo
		ld		hl, (se_bomb2)
		call	bgmdriver_play_sound_effect
		; @Ƀ_[W^
		ld		a, (player_shield)
		dec		a
		push	af
		ld		(player_shield), a
		call	background_update_player_info
		pop		af
		jp		z, goto_gameover
		ld		a, #240								; _[W󂯂Ǝ@ 4bԖGɂȂ
		ld		(player_invincibility), a
		ret

check_player_clash_sub:
		; @ƓG̓蔻
		ld		ix, #player_info
		ld		iy, #enemy_info0
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip1
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip1:

		ld		iy, #enemy_info1
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip2
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip2:

		ld		iy, #enemy_info2
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip3
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip3:

		ld		iy, #enemy_info3
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip4
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip4:

		ld		iy, #enemy_info4
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip5
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip5:

		ld		iy, #enemy_info5
		ld		a, SCA_INFO_ENEMY_POWER(iy)
		or		a
		jr		z, check_player_clash_sub_skip6
		call	check_clash_12x12
		ret		c
check_player_clash_sub_skip6:

		; @ƓGe̓蔻
		ld		de, #SCA_INFO_SIZE
		ld		b, #15
		ld		iy, #eshot_info
check_player_clash_loop:
		call	check_clash_4x4
		ret		c
		add		iy, de							; オ肵Ȃ CtO = 0
		djnz	check_player_clash_loop			; djnz  CtOs
		ret

		; @ƃX{X̂蔻
check_player_clash_sub2::
		ld		ix, #player_info
		ld		a, #8
		add		a, SCA_INFO_XH(ix)
		ld		h, a
		ld		l, SCA_INFO_YH(ix)
		; WʒũLN^擾
		call	background_get_fore_char
		cp		#96								; X{X̃p[c 96ȍ~ 
		ccf
		ret

; -----------------------------------------------------------------------------
;	G蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: @eɏՓ˂Ă
;	break
;		a, f, b, d, e, h, l, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_enemy_clash::
		ld		hl, (crash_check_routine)
		jp		(hl)

check_enemy_normal_clash::
		ld		ix, #enemy_info0
		ld		b, #6							; G͍őU@
check_enemy_clash_loop1:
		push	bc
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		z, check_enemy_clash_skip1		; 쒆łȂGƂ͂蔻肵Ȃ
		ld		iy, #shot_info0
		call	check_clash_12x12
		call	c, enemy_clash
		ld		iy, #shot_info1
		call	check_clash_12x12
		call	c, enemy_clash
		ld		iy, #shot_info2
		call	check_clash_12x12
		call	c, enemy_clash
check_enemy_clash_skip1:
		ld		de, #(SCA_INFO_SIZE * 2)
		add		ix, de
		pop		bc
		djnz	check_enemy_clash_loop1
		ret

; -----------------------------------------------------------------------------
;	{X1蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: @eɏՓ˂Ă
;	break
;		a, f, b, d, e, h, l, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_enemy_boss1_clash:
		ld		ix, #enemy_info0
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		z, check_enemy_boss1_clash_skip1		; 쒆łȂGƂ͂蔻肵Ȃ
		ld		iy, #shot_info0
		call	check_clash_boss1
		call	c, enemy_boss1_clash
		ld		iy, #shot_info1
		call	check_clash_boss1
		call	c, enemy_boss1_clash
		ld		iy, #shot_info2
		call	check_clash_boss1
		call	c, enemy_boss1_clash
check_enemy_boss1_clash_skip1:
		ret

; -----------------------------------------------------------------------------
;	X{X蔻
;	input:
;		Ȃ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: @eɏՓ˂Ă
;	break
;		a, f, b, d, e, h, l, ix, iy
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_enemy_boss8_clash:
		ld		ix, #shot_info0
		call	boss8_clash_sub

		ld		ix, #shot_info1
		call	boss8_clash_sub

		ld		ix, #shot_info2
		call	boss8_clash_sub
		ret

; -----------------------------------------------------------------------------
;	@eƃX{X̂蔻(P)
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
boss8_clash_sub:
		; e̍W
		ld		a, #4
		add		a, SCA_INFO_XH(ix)
		ld		h, a
		ld		l, SCA_INFO_YH(ix)
		ld		a, l
		cp		#212
		ret		z								; ˒łȂΔjłȂ
		; WʒũLN^擾
		call	background_get_fore_char
		cp		#96								; X{X̃p[c 96ȍ~ 
		jp		c, boss8_clash_sub_skip1
		cp		#106							; X{X̎_p[c 106ȍ~ ł邩H
		jp		nc, boss8_clash_sub_skip2

boss8_clash_sub_skip1:
		inc		hl								; Eׂׂ
		ld		a, (hl)
		cp		#96								; X{X̃p[c 96ȍ~ 
		ret		c
		cp		#106							; X{X̎_p[c 106ȍ~ ł邩H
		jp		c, boss8_no_damage
boss8_clash_sub_skip2:
		ld		SCA_INFO_YH(ix), #212			; @e \
		ld		SCA_INFO_SHOT_POWER(ix), #0		; ˒łȂ
		; ǂ̃p[cɃ_[W^ׂ̂
		ld		a, (SCA_INFO_ENEMY_POWER + enemy_info0)
		ld		b, a
		ld		a, (SCA_INFO_ENEMY_POWER3 + enemy_info0)
		or		b								; p[c͑ҋ@H
		jp		z, boss8_center_damage			; ҋ@łȂ΁Ap[c݂Ȃp[cɃ_[W
		ld		a, SCA_INFO_XH(ix)
		cp		#192/2
		jp		nc, boss8_right_damage			; EȂEp[cփ_[W
boss8_left_damage::
		ld		a, (SCA_INFO_ENEMY_POWER + enemy_info0)
		dec		a								; p[cɃ_[W^ (@ ShotPower Ɋւ炸 1_[W)
		ld		(SCA_INFO_ENEMY_POWER + enemy_info0), a
		jp		nz, boss8_damage
		ld		a, (SCA_INFO_XL + enemy_info0)	; p[c̕\
		ld		e, a
		ld		a, (SCA_INFO_YL + enemy_info0)
		ld		d, a
		call	draw_boss8_delete
		jp		boss8_destroy

boss8_right_damage::
		ld		a, (SCA_INFO_ENEMY_POWER3 + enemy_info0)
		dec		a								; Ep[cɃ_[W^ (@ ShotPower Ɋւ炸 1_[W)
		ld		(SCA_INFO_ENEMY_POWER3 + enemy_info0), a
		jp		nz, boss8_damage
		ld		a, (SCA_INFO_XL2 + enemy_info0)	; Ep[c̕\
		ld		e, a
		ld		a, (SCA_INFO_YL2 + enemy_info0)
		ld		d, a
		call	draw_boss8_delete
		jp		boss8_destroy

boss8_center_damage::							; p[cɃ_[W^ꍇ
		ld		a, (SCA_INFO_ENEMY_POWER5 + enemy_info0)
		dec		a								; p[cɃ_[W^ (@ ShotPower Ɋւ炸 1_[W)
		ld		(SCA_INFO_ENEMY_POWER5 + enemy_info0), a
		jp		nz, boss8_damage
		ld		a, (SCA_INFO_XL3 + enemy_info0)	; Ep[c̕\
		ld		e, a
		ld		a, (SCA_INFO_YL3 + enemy_info0)
		ld		d, a
		call	draw_boss8_center_delete
		ld		hl, (se_bomb2)							; {Xj
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x9999								; p[cj 9999_
		call	score_add
		call	top_score_check
		call	score_update
		; {Xjvs
		call	enemy_boss_destroy_request
		; BGMt~
		call	bgmdriver_stop
		ret

boss8_destroy:
		ld		a, (SCA_INFO_ENEMY_POWER + enemy_info0)		; p[c
		ld		b, a
		ld		a, (SCA_INFO_ENEMY_POWER3 + enemy_info0)	; Ep[c
		or		b
		jp		nz, boss8_destroy_skip1
		; p[c̏Ԃ
		xor		a
		ld		(SCA_INFO_ENEMY_STATE_L + enemy_info0), a
		ld		(SCA_INFO_ENEMY_STATE_H + enemy_info0), a
		ld		(SCA_INFO_ENEMY_STATE_L2 + enemy_info0), a
		ld		(SCA_INFO_ENEMY_STATE_H2 + enemy_info0), a
boss8_destroy_skip1:
		ld		hl, (se_bomb2)					; {Xj
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x5000								; Ep[cj 5000_
		call	score_add
		call	top_score_check
		call	score_update
		ret

boss8_damage:
		ld		hl, (se_damage)					; _[W^炷
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x0003						; {X_[W 3_
		call	score_add
		call	top_score_check
		call	score_update
		ret

boss8_no_damage:								; X{X_[WHȂɒe
		ld		SCA_INFO_YH(ix), #212			; @e \
		ld		SCA_INFO_SHOT_POWER(ix), #0		; ˒łȂ
		ld		hl, (se_no_damage)				; _[W^Ȃ炷
		call	bgmdriver_play_sound_effect
		ret

; -----------------------------------------------------------------------------
;	GƎ@eՓ˂Ƃ̏
;	input:
;		ix	...	Փ˂G̃AhX
;		iy	...	Փ˂ẽAhX
;	output
;		Ȃ
;	break
;		a, f, b, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
enemy_clash:
		; GɃ_[W^
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		sub		SCA_INFO_SHOT_POWER(iy)
		; Gꂽ
		jr		c, enemy_clash_enemy_destroy			; ꂽꍇAG
		jr		z, enemy_clash_enemy_destroy			; ꂽꍇAG
		ld		SCA_INFO_ENEMY_POWER(ix), a				; ϋv͂XV
		; GɃ_[W^𔭐
		ld		hl, (se_damage)
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x2								; G_[W 2_
		call	score_add
		call	top_score_check
		call	score_update
enemy_clash_shot_destroy:
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		ret
		; G
enemy_clash_enemy_destroy:
		; G𔭐
		ld		hl, (se_bomb)
		call	bgmdriver_play_sound_effect
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		; G𔚔p^[ɕύX
		call	enemy_bomb
		; _ǉ
		ld		de, #0x100								; Gj 100_
		call	score_add
		call	top_score_check
		call	score_update
		ret

; -----------------------------------------------------------------------------
;	{XƎ@eՓ˂Ƃ̏
;	input:
;		iy	...	Փ˂ẽAhX
;	output
;		Ȃ
;	break
;		a, f, b, d, e, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
enemy_boss1_clash:
		ld		ix, #enemy_info0
		; GɃ_[W^
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		sub		SCA_INFO_SHOT_POWER(iy)
		; Gꂽ
		jr		c, enemy_boss1_clash_enemy_destroy			; ꂽꍇAG
		jr		z, enemy_boss1_clash_enemy_destroy			; ꂽꍇAG
		ld		SCA_INFO_ENEMY_POWER(ix), a				; ϋv͂XV
		; GɃ_[W^𔭐
		ld		hl, (se_damage)
		call	bgmdriver_play_sound_effect
enemy_boss1_clash_shot_destroy:
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		; _ǉ
		ld		de, #0x0003								; {X_[W 3_
		call	score_add
		call	top_score_check
		call	score_update
		ret
		; G
enemy_boss1_clash_enemy_destroy:
		; G𔭐
		ld		hl, (se_bomb2)
		call	bgmdriver_play_sound_effect
		; Փ˂@eł
		ld		SCA_INFO_YH(iy), #212					; \
		ld		SCA_INFO_SHOT_POWER(iy), #0				; ˒łȂ
		; G𔚔p^[ɕύX
		call	enemy_bomb
		ld		ix, #enemy_info1
		call	enemy_bomb
		ld		ix, #enemy_info2
		call	enemy_bomb
		ld		ix, #enemy_info3
		call	enemy_bomb
		; _ǉ
		ld		de, #0x5000								; {Xj 5000_
		call	score_add
		call	top_score_check
		call	score_update
		; {Xjvs
		call	enemy_boss_destroy_request
		; BGMt~
		call	bgmdriver_stop
		ret

; -----------------------------------------------------------------------------
;	@eƒn㕨̂蔻
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
plant_clash::
		ld		ix, #shot_info0
		call	plant_clash_sub

		ld		ix, #shot_info1
		call	plant_clash_sub

		ld		ix, #shot_info2
		call	plant_clash_sub
		ret

; -----------------------------------------------------------------------------
;	@eƒn㕨̂蔻(P)
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
plant_clash_sub:
		; e̍W
		ld		a, #4
		add		a, SCA_INFO_XH(ix)
		ld		h, a
		ld		l, SCA_INFO_YH(ix)
		ld		a, l
		cp		#8
		ret		c								; [ɔĂn㕨͔jłȂ
		cp		#212
		ret		z								; ˒łȂΔjłȂ
		; WʒũLN^擾
		call	background_get_char
		and		#0xFC
		cp		#76
		jp		z, check_item					; n㕨Ȃp[AbvACeo֔
		inc		hl								; Eׂׂ
		ld		a, (hl)
		and		#0xFC
		cp		#76
		ret		nz
check_item:
		; p[AbvACe
		ld		a, (item_timing)
		inc		a
		and		#31
		ld		(item_timing), a
		jr		nz, plant_clash_sub_skip1		; n㕨 32j󂷂邽тɃACeo
		; p[AbvACeo
		push	hl
		call	random
		ld		a, l
		pop		hl
		and		#8
		ld		a, #80							; Xs[hAbvACe
		jr		z, plant_clash_sub_skip2
		ld		a, #84							; Vbgp[AbvACe
		jr		plant_clash_sub_skip2
plant_clash_sub_skip1:
		; n㕨j󂷂
		ld		a, #72
plant_clash_sub_skip2:
		call	background_put_char
		; G𔭐
		ld		hl, (se_bomb)
		call	bgmdriver_play_sound_effect
		; Փ˂@eł
		ld		SCA_INFO_YH(ix), #212			; \
		ld		SCA_INFO_SHOT_POWER(ix), #0		; ˒łȂ
		; _ǉ
		ld		de, #0x50						; n㕨j 50_
		call	score_add
		call	top_score_check
		call	score_update
		ret

; -----------------------------------------------------------------------------
;	@ƃACê蔻
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
player_get_item_check::
		; @̍W
		ld		ix, #player_info
		ld		a, #8
		add		a, SCA_INFO_XH(ix)
		ld		h, a
		ld		a, #8
		add		a, SCA_INFO_YH(ix)
		ld		l, a
		cp		#8
		ret		c								; [ɔĂACe͎Ȃ
		cp		#192-8
		ret		nc								; [ɔĂACe͎Ȃ
		; WʒũLN^擾
		call	background_get_char
		and		#0xFC
		cp		#88
		ret		nc								; ACeȂꍇ͔
		cp		#80
		ret		c								; ACeȂꍇ͔
		; n㕨j󂷂
		push	af
		ld		a, #72
		call	background_put_char
		; ACe擾̉𔭐
		ld		hl, (se_get_item)
		call	bgmdriver_play_sound_effect
		; _ǉ
		ld		de, #0x100						; ACe擾 100_
		call	score_add
		call	top_score_check
		call	score_update
		; Xs[hAbvVbgp[Abv̔
		pop		af
		cp		#80
		jp		z, player_speed_up
		jp		player_shot_power_up

; -----------------------------------------------------------------------------
;	12x12 蔻
;	input:
;		ix	...	ΏۂP
;		iy	...	ΏۂQ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_12x12:
		; A  ABS( ix(SCA_INFO_XH) - iy(SCA_INFO_XH) )
		ld		a, SCA_INFO_XH(ix)
		sub		SCA_INFO_XH(iy)
		jr		nc, check_clash_12x12_skip1
		neg
check_clash_12x12_skip1:
		; if a >= 12 then return
		cp		#12
		ret		nc
		; A  ABS( ix(SCA_INFO_YH) - iy(SCA_INFO_YH) )
		ld		a, SCA_INFO_YH(ix)
		sub		SCA_INFO_YH(iy)
		jr		nc, check_clash_12x12_skip2
		neg
check_clash_12x12_skip2:
		; if a >= 12 then return
		cp		#12
		ret

; -----------------------------------------------------------------------------
;	{X1 蔻
;	input:
;		ix	...	{X
;		iy	...	Vbg
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_boss1:
		; A  ix(SCA_INFO_XH) - iy(SCA_INFO_XH)
		ld		a, SCA_INFO_XH(iy)
		sub		SCA_INFO_XH(ix)
		cp		#-10
		jp		m, check_clash_boss1_no_crash
		cp		#22
		jp		p, check_clash_boss1_no_crash
		; A  ix(SCA_INFO_YH) - iy(SCA_INFO_YH)
		ld		a, SCA_INFO_YH(iy)
		sub		SCA_INFO_YH(ix)
		cp		#-16
		jp		m, check_clash_boss1_no_crash
		cp		#32
		jp		p, check_clash_boss1_no_crash
		scf
		ret
check_clash_boss1_no_crash:
		or		a
		ret

; -----------------------------------------------------------------------------
;	4x4 蔻
;	input:
;		ix	...	ΏۂP
;		iy	...	ΏۂQ
;	output
;		ctO ... 0: Փ˂ĂȂ, 1: Փ˂Ă
;	break
;		a, f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
check_clash_4x4:
		; A  ABS( ix(SCA_INFO_XH) - iy(SCA_INFO_XH) )
		ld		a, SCA_INFO_XH(ix)
		sub		SCA_INFO_XH(iy)
		jr		nc, check_clash_4x4_skip1
		neg
check_clash_4x4_skip1:
		; if a >= 4 then return
		cp		#4
		ret		nc
		; A  ABS( ix(SCA_INFO_YH) - iy(SCA_INFO_YH) )
		ld		a, SCA_INFO_YH(ix)
		sub		SCA_INFO_YH(iy)
		jr		nc, check_clash_4x4_skip2
		neg
check_clash_4x4_skip2:
		; if a >= 4 then return
		cp		#4
		ret

; -----------------------------------------------------------------------------
;	G蔻胋[`̂ւ
;	input:
;		a	...	蔻胋[`̔ԍ
;				0: ʏ̓G
;				1: {X1
;	output
;		Ȃ
;	break
;		a, f, h, l
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
change_crash_check_routine::
		cp		#1
		jp		c, change_crash_check_routine1
		jp		z, change_crash_check_routine2
		jp		change_crash_check_routine3

change_crash_check_routine1:
		ld		hl, #check_enemy_normal_clash
		ld		(crash_check_routine), hl
		ret

change_crash_check_routine2:
		ld		hl, #check_enemy_boss1_clash
		ld		(crash_check_routine), hl
		ret

change_crash_check_routine3:
		ld		hl, #check_enemy_boss8_clash
		ld		(crash_check_routine), hl
		ret

; -----------------------------------------------------------------------------
;	蔻胋[`̃AhX
; -----------------------------------------------------------------------------
crash_check_routine:
		.dw		#enemy_clash

; -----------------------------------------------------------------------------
;	p[AbvACeo^C~O
; -----------------------------------------------------------------------------
item_timing::
		.db		#0
