; -----------------------------------------------------------------------------
;	{XG3̏
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.area	CODE (ABS)

		.globl	enemy_get_cos
		.globl	random
		.globl	enemy_shot_start
		.globl	player_info
		.globl	sprite_set_color
		.globl	sprite_attribute_table
		.globl	change_crash_check_routine

; -----------------------------------------------------------------------------
;	{X3̈ړ
;	input:
;		ix	...	G̃AhX
;	output
;		Ȃ
;	break
;		a,f,b,c,h,l
; -----------------------------------------------------------------------------
enemy_boss3_move::
		; ̃{X쒆łȂΉȂ
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		nz, enemy_boss3_move_active
enemy_boss3_inactive:
		ld		SCA_INFO_YH(ix), #212			; \
		ld		SCA_INFO_YH2(ix), #212			; \
		ld		SCA_INFO_YH3(ix), #212			; \
		ld		SCA_INFO_YH4(ix), #212			; \
		ld		SCA_INFO_YH5(ix), #212			; \
		ld		SCA_INFO_YH6(ix), #212			; \
		ld		SCA_INFO_YH7(ix), #212			; \
		ld		SCA_INFO_YH8(ix), #212			; \
		ld		SCA_INFO_ENEMY_POWER(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER3(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER5(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER7(ix), #0	; 쓮łȂ
		ret
enemy_boss3_move_active:
		ld		a, SCA_INFO_YH(ix)
		add		a, SCA_INFO_ENEMY_STATE_L(ix)	; Y̑
		cp		#192-32
		jp		c, enemy_boss3_move_y
		cp		#240
		jp		c, enemy_boss3_move_y_right
		ld		a, #3
		ld		SCA_INFO_ENEMY_STATE_L(ix), a
		xor		a
		jp		enemy_boss3_move_y
enemy_boss3_move_y_right:
		ld		a, #-3
		ld		SCA_INFO_ENEMY_STATE_L(ix), a
		ld		a, #192-32
enemy_boss3_move_y:
		; YWXV
		ld		SCA_INFO_YH(ix), a
		ld		SCA_INFO_YH2(ix), a
		ld		SCA_INFO_YH3(ix), a
		ld		SCA_INFO_YH4(ix), a
		add		a, #16
		ld		SCA_INFO_YH5(ix), a
		ld		SCA_INFO_YH6(ix), a
		ld		SCA_INFO_YH7(ix), a
		ld		SCA_INFO_YH8(ix), a

		ld		a, SCA_INFO_XH(ix)
		add		a, SCA_INFO_ENEMY_STATE_H(ix)	; X̑
		cp		#192-32
		jp		c, enemy_boss3_move_x
		cp		#240
		jp		c, enemy_boss3_move_x_bottom
		ld		a, #3
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		xor		a
		jp		enemy_boss3_move_y
enemy_boss3_move_x_bottom:
		ld		a, #-3
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		ld		a, #192-32
enemy_boss3_move_x:
		ld		SCA_INFO_XH(ix), a
		; XWXV
		ld		SCA_INFO_XH(ix), a
		ld		SCA_INFO_XH2(ix), a
		ld		SCA_INFO_XH5(ix), a
		ld		SCA_INFO_XH6(ix), a
		add		a, #16
		ld		SCA_INFO_XH3(ix), a
		ld		SCA_INFO_XH4(ix), a
		ld		SCA_INFO_XH7(ix), a
		ld		SCA_INFO_XH8(ix), a

enemy_boss3_move_fire:
		; e𔭎˂^C~OH
		ld		a, SCA_INFO_ENEMY_SHOT_TIMING(ix)
		inc		a
		and		#7
		ld		SCA_INFO_ENEMY_SHOT_TIMING(ix), a
		jr		nz, enemy_boss3_move_end					; ˂̃^C~OłȂ enemy_boss3_move_end 
		; ˏ
		ld		iy, #player_info
		call	enemy_shot_start
enemy_boss3_move_end:
enemy_boss3_move_dummy:
		ret

; -----------------------------------------------------------------------------
;	{X3̓oꏈ
;		iy	... G̃AhX
;	output
;		Ȃ
;	break
;		a,b,d,e,f,h,l,iy
; -----------------------------------------------------------------------------
enemy_boss3_start::
		; 蔻{Xpɐ؂ւ
		ld		a, #1
		call	change_crash_check_routine
		; {XV[hXV
		ld		a, #96
		ld		SCA_INFO_ENEMY_POWER(iy), a
		ld		SCA_INFO_ENEMY_POWER3(ix), a
		ld		SCA_INFO_ENEMY_POWER5(ix), a
		ld		SCA_INFO_ENEMY_POWER7(ix), a
		; ړxNg
		ld		a, #3
		ld		SCA_INFO_ENEMY_STATE_L(iy), a
		ld		SCA_INFO_ENEMY_STATE_H(iy), a
		; YWXV
		xor		a
		ld		SCA_INFO_YH(iy), a
		ld		SCA_INFO_YH2(iy), a
		ld		SCA_INFO_YH3(iy), a
		ld		SCA_INFO_YH4(iy), a
		add		a, #16
		ld		SCA_INFO_YH5(iy), a
		ld		SCA_INFO_YH6(iy), a
		ld		SCA_INFO_YH7(iy), a
		ld		SCA_INFO_YH8(iy), a
		; XWXV
		ld		a, #96 - 16 - 29
		ld		SCA_INFO_XH(iy), a
		ld		SCA_INFO_XH2(iy), a
		ld		SCA_INFO_XH5(iy), a
		ld		SCA_INFO_XH6(iy), a
		add		a, #16
		ld		SCA_INFO_XH3(iy), a
		ld		SCA_INFO_XH4(iy), a
		ld		SCA_INFO_XH7(iy), a
		ld		SCA_INFO_XH8(iy), a
		ld		hl, #enemy_boss3_move
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		ld		hl, #enemy_boss3_move_dummy
		ld		de, #SCA_INFO_SIZE * 2
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		; XvCg̐FύX
		ld		a, #2
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #3
		ld		c, #0x42
		call	sprite_set_color
		ld		a, #4
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #5
		ld		c, #0x42
		call	sprite_set_color
		ld		a, #6
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #7
		ld		c, #0x42
		call	sprite_set_color
		ld		a, #8
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #9
		ld		c, #0x42
		call	sprite_set_color
		; XvCgp^[ԍύX
		ld		hl, #(sprite_attribute_table + 2 + 2*4)
		ld		de, #4
		;		p^[ԍ
		ld		(hl), #(16 * 4)
		add		hl, de
		ld		(hl), #(17 * 4)
		add		hl, de
		ld		(hl), #(18 * 4)
		add		hl, de
		ld		(hl), #(19 * 4)
		add		hl, de
		ld		(hl), #(20 * 4)
		add		hl, de
		ld		(hl), #(21 * 4)
		add		hl, de
		ld		(hl), #(22 * 4)
		add		hl, de
		ld		(hl), #(23 * 4)
		ret
