; -----------------------------------------------------------------------------
;	{XG8̏
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"
		.include	"bgmdriver_h.asm"

		.area	CODE (ABS)

		.globl	enemy_get_cos
		.globl	random
		.globl	enemy_shot_start
		.globl	player_info
		.globl	sprite_set_color
		.globl	sprite_attribute_table
		.globl	change_crash_check_routine
		.globl	draw_boss8_left
		.globl	draw_boss8_right
		.globl	draw_boss8_center
		.globl	draw_boss8_center2
		.globl	background_draw_laser
		.globl	enemy_shot_search
		.globl	enemy_shot_start_one
		.globl	enemy_shot_start_one2

LEFT_PART_1ST_DOWN_TIME		= 5					; p[cŏɉֈړ܂ł̎ [b]
RIGHT_PART_1ST_DOWN_TIME	= 7					; Ep[cŏɉֈړ܂ł̎ [b]
LEFT_PART_DOWN_CYCLE		= 6					; ֈړ鎞ԊԊu
RIGHT_PART_DOWN_CYCLE		= 8					; ֈړ鎞ԊԊu
LEFT_PART_DOWN_SPEED		= 6					; ֈړ鑬x
RIGHT_PART_DOWN_SPEED		= 6					; ֈړ鑬x
CENTER_MOVE_SPEED			= 5					; p[cPƎ̈ړx
CENTER_BEFORE_LASER_WAIT	= 50				; [U[ˑO̍d
CENTER_AFTER_LASER_WAIT		= 180				; [U[˒̍d
CENTER_LASER_CYCLE			= 60				; [U[ˊԊu
SHOT_CYCLE					= 5					; e𔭎˂Ԋu
SHOT_TYPE_CHANGE			= 15				; SHOT_TYPE_CHANGEɂP񎩋@ƏŔ

; -----------------------------------------------------------------------------
;	{X8̈ړ
;	input:
;		ix	...	G̃AhX
;	output
;		Ȃ
;	break
;		a,f,b,c,h,l
; -----------------------------------------------------------------------------
enemy_boss8_move::
		call	enemy_boss8_move_left			; p[c
		call	enemy_boss8_move_right			; Ep[c
		call	enemy_boss8_move_center			; p[c
enemy_boss8_move_dummy:
		ret

enemy_boss8_move_left:
		; p[cłɔjς݂Ȃ牽Ȃ
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		ret		z
		; eˏ
		ld		a, SCA_INFO_XL(ix)
		add		a, #7
		rlca
		rlca
		rlca
		ld		c, a
		ld		a, SCA_INFO_YL(ix)
		add		a, #3
		rlca
		rlca
		rlca
		ld		b, a
		call	enemy_boss8_shot
		; Ԕ
		ld		a, SCA_INFO_ENEMY_STATE_L(ix)
		cp		#1
		jp		c, enemy_boss8_left_s0
		jp		z, enemy_boss8_left_s1
		jp		enemy_boss8_left_s2

enemy_boss8_left_s0:
		; bJEg^C}[
		ld		a, (wait_timer_left)
		dec		a
		ld		(wait_timer_left), a
		ret		nz
		ld		a, #60
		ld		(wait_timer_left), a
		; p[cҋ@Ȃ牽Ȃ
		ld		a, SCA_INFO_ENEMY_STATE_H(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		ret		nz
		; ֈړ^C~OɂȂ̂ S1 ֑J
		ld		a, #1
		ld		SCA_INFO_ENEMY_STATE_L(ix), a
		ld		a, #LEFT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		ret

enemy_boss8_left_s1:
		; Xs[hJE^
		ld		a, SCA_INFO_ENEMY_STATE_H(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		ret		nz
		ld		a, #LEFT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		; ֈړ
		ld		a, SCA_INFO_YL(ix)
		inc		a
		ld		SCA_INFO_YL(ix), a
		cp		#13
		jp		nz, enemy_boss8_left_s1_skip1
		; 13ɓBꍇ͎̏Ԃ֑J
		ld		a, #2
		ld		SCA_INFO_ENEMY_STATE_L(ix), a
enemy_boss8_left_s1_skip1:
		; K\XV
		ld		e, SCA_INFO_XL(ix)
		ld		d, SCA_INFO_YL(ix)
		call	draw_boss8_left
		ld		a, #1
		ld		(boss_center_update), a
		ret

enemy_boss8_left_s2:
		; Xs[hJE^
		ld		a, SCA_INFO_ENEMY_STATE_H(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		ret		nz
		ld		a, #LEFT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
		; ֈړ
		ld		a, SCA_INFO_YL(ix)
		dec		a
		ld		SCA_INFO_YL(ix), a
		jp		nz, enemy_boss8_left_s2_skip1
		; 0ɓBꍇ͎̏Ԃ֑J
		ld		SCA_INFO_ENEMY_STATE_L(ix), a
		ld		a, #LEFT_PART_DOWN_CYCLE
		ld		SCA_INFO_ENEMY_STATE_H(ix), a
enemy_boss8_left_s2_skip1:
		; K\XV
		ld		e, SCA_INFO_XL(ix)
		ld		d, SCA_INFO_YL(ix)
		call	draw_boss8_left
		ld		a, #1
		ld		(boss_center_update), a
		ret

enemy_boss8_move_right::
		; Ep[cłɔjς݂Ȃ牽Ȃ
		ld		a, SCA_INFO_ENEMY_POWER3(ix)
		or		a
		ret		z
		; eˏ
		ld		a, SCA_INFO_XL2(ix)
		rlca
		rlca
		rlca
		ld		c, a
		ld		a, SCA_INFO_YL2(ix)
		add		a, #3
		rlca
		rlca
		rlca
		ld		b, a
		call	enemy_boss8_shot
		; Ԕ
		ld		a, SCA_INFO_ENEMY_STATE_L2(ix)
		cp		#1
		jp		c, enemy_boss8_right_s0
		jp		z, enemy_boss8_right_s1
		jp		enemy_boss8_right_s2

enemy_boss8_right_s0:
		; bJEg^C}[
		ld		a, (wait_timer_right)
		dec		a
		ld		(wait_timer_right), a
		ret		nz
		ld		a, #60
		ld		(wait_timer_right), a
		; Ep[cҋ@Ȃ牽Ȃ
		ld		a, SCA_INFO_ENEMY_STATE_H2(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		ret		nz
		; ֈړ^C~OɂȂ̂ S1 ֑J
		ld		a, #1
		ld		SCA_INFO_ENEMY_STATE_L2(ix), a
		ld		a, #RIGHT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		ret

enemy_boss8_right_s1:
		; Xs[hJE^
		ld		a, SCA_INFO_ENEMY_STATE_H2(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		ret		nz
		ld		a, #RIGHT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		; ֈړ
		ld		a, SCA_INFO_YL2(ix)
		inc		a
		ld		SCA_INFO_YL2(ix), a
		cp		#13
		jp		nz, enemy_boss8_right_s1_skip1
		; 13ɓBꍇ͎̏Ԃ֑J
		ld		a, #2
		ld		SCA_INFO_ENEMY_STATE_L2(ix), a
enemy_boss8_right_s1_skip1:
		; K\XV
		ld		e, SCA_INFO_XL2(ix)
		ld		d, SCA_INFO_YL2(ix)
		call	draw_boss8_right
		ld		a, #1
		ld		(boss_center_update), a
		ret

enemy_boss8_right_s2:
		; Xs[hJE^
		ld		a, SCA_INFO_ENEMY_STATE_H2(ix)
		dec		a
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		ret		nz
		ld		a, #RIGHT_PART_DOWN_SPEED
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
		; ֈړ
		ld		a, SCA_INFO_YL2(ix)
		dec		a
		ld		SCA_INFO_YL2(ix), a
		jp		nz, enemy_boss8_right_s2_skip1
		; 0ɓBꍇ͎̏Ԃ֑J
		ld		SCA_INFO_ENEMY_STATE_L2(ix), a
		ld		a, #RIGHT_PART_DOWN_CYCLE
		ld		SCA_INFO_ENEMY_STATE_H2(ix), a
enemy_boss8_right_s2_skip1:
		; K\XV
		ld		e, SCA_INFO_XL2(ix)
		ld		d, SCA_INFO_YL2(ix)
		call	draw_boss8_right
		ld		a, #1
		ld		(boss_center_update), a
		ret

enemy_boss8_move_center:
		ld		a, SCA_INFO_ENEMY_POWER5(ix)
		or		a
		ret		z								; p[cłɔjς ܂ state0 Ȃ牽Ȃ

		; eˏ
		ld		a, SCA_INFO_XL3(ix)
		add		a, #4
		rlca
		rlca
		rlca
		ld		c, a
		ld		a, SCA_INFO_YL3(ix)
		add		a, #6
		rlca
		rlca
		rlca
		ld		b, a
		call	enemy_boss8_shot

		ld		a, SCA_INFO_ENEMY_STATE_H3(ix)
		cp		#1
		jp		c, enemy_boss8_center_s0
		jp		z, enemy_boss8_center_s1
		cp		#3
		jp		c, enemy_boss8_center_s2
		jp		enemy_boss8_center_s3

enemy_boss8_center_s0:
		; XV^C}[
		ld		a, (wait_timer_center)
		dec		a
		ld		(wait_timer_center), a
		jp		nz, enemy_boss8_center_force_update
		ld		a, #CENTER_MOVE_SPEED
		ld		(wait_timer_center), a
		; [U[˃^C~O
		ld		a, (wait_timer_laser)
		dec		a
		ld		(wait_timer_laser), a
		jp		nz, enemy_boss8_center_force_update
		; [U[ˏԂɑJ
		ld		hl, (se_pre_laser)
		call	bgmdriver_play_sound_effect
		ld		a, #CENTER_LASER_CYCLE
		ld		(wait_timer_laser), a
		ld		a, #CENTER_BEFORE_LASER_WAIT
		ld		(wait_timer_left), a
		ld		a, #2
		ld		SCA_INFO_ENEMY_STATE_H3(ix), a
		ld		e, SCA_INFO_XL3(ix)
		ld		d, SCA_INFO_YL3(ix)
		jp		draw_boss8_center
enemy_boss8_center_force_update:
		ld		a, (boss_center_update)
		or		a
		ret		z
		xor		a
		ld		(boss_center_update), a
enemy_boss8_move_center_active:
		ld		e, SCA_INFO_XL3(ix)
		ld		d, SCA_INFO_YL3(ix)
		jp		draw_boss8_center

enemy_boss8_center_s1:
		; XV^C}[
		ld		a, (wait_timer_center)
		dec		a
		ld		(wait_timer_center), a
		ret		nz
		ld		a, #CENTER_MOVE_SPEED
		ld		(wait_timer_center), a
		; [U[˃^C~O
		ld		a, (wait_timer_laser)
		dec		a
		ld		(wait_timer_laser), a
		jp		nz, enemy_boss8_move_center_active2
		; [U[ˏԂɑJ
		ld		hl, (se_pre_laser)
		call	bgmdriver_play_sound_effect
		ld		a, #CENTER_LASER_CYCLE
		ld		(wait_timer_laser), a
		ld		a, #CENTER_BEFORE_LASER_WAIT
		ld		(wait_timer_left), a
		ld		a, #2
		ld		SCA_INFO_ENEMY_STATE_H3(ix), a
		ld		e, SCA_INFO_XL3(ix)
		ld		d, SCA_INFO_YL3(ix)
		jp		draw_boss8_center2

enemy_boss8_move_center_active2::
		; XẄʑp
		ld		l, SCA_INFO_ENEMY_STATE_L(ix)
		ld		h, SCA_INFO_ENEMY_STATE_H(ix)
		ld		de, #5
		add		hl, de
		ld		SCA_INFO_ENEMY_STATE_L(ix), l
		ld		SCA_INFO_ENEMY_STATE_H(ix), h
		; b = 72*sin
		call	enemy_get_cos
		; a = b*0.1 = (b*3 >> 5) + 7
		; 72*3 = 216 Ȃ̂ >> 1  108 ɂȂAt 8bit Ɏ܂
		xor		a
		ld		l, b
		ld		h, a
		ld		e, b
		ld		d, a
		add		hl, de
		add		hl, de
		xor		a
		cp		h
		rr		l
		ld		a, l
		sra		a
		sra		a
		sra		a
		sra		a
		add		a, #7
		ld		SCA_INFO_XL3(ix), a
		; YẄʑp
		ld		l, SCA_INFO_ENEMY_STATE_L2(ix)
		ld		h, SCA_INFO_ENEMY_STATE_H2(ix)
		ld		de, #15
		add		hl, de
		ld		SCA_INFO_ENEMY_STATE_L2(ix), l
		ld		SCA_INFO_ENEMY_STATE_H2(ix), h
		; c = 72*cos
		call	enemy_get_cos
		ld		a, c
		; a = c/16 + 5 = (c >> 4) + 5
		sra		a
		sra		a
		sra		a
		sra		a
		neg
		add		a, #5
		ld		SCA_INFO_YL3(ix), a
		ld		e, SCA_INFO_XL3(ix)
		ld		d, a
		xor		a
		jp		draw_boss8_center2

enemy_boss8_center_s2:							; [U[ˏ
		ld		a, (wait_timer_left)
		dec		a
		ld		(wait_timer_left), a
		jp		nz, enemy_boss8_center_force_update
		ld		a, #CENTER_AFTER_LASER_WAIT
		ld		(wait_timer_left), a
		; [U[ˉ
		ld		hl, (se_laser)
		call	bgmdriver_play_sound_effect
		; [U[`
		ld		e, SCA_INFO_XL3(ix)
		ld		d, SCA_INFO_YL3(ix)
		ld		a, #105
		call	background_draw_laser
		ld		a, #3
		ld		SCA_INFO_ENEMY_STATE_H3(ix), a
		ret

enemy_boss8_center_s3:							; [U[˒
		ld		a, (wait_timer_left)
		dec		a
		ld		(wait_timer_left), a
		jp		nz, enemy_boss8_center_force_update
		ld		a, #CENTER_MOVE_SPEED
		ld		(wait_timer_left), a
		; [U[~
		ld		hl, (se_stop)
		call	bgmdriver_play_sound_effect
		; [U[
		ld		e, SCA_INFO_XL3(ix)
		ld		d, SCA_INFO_YL3(ix)
		xor		a
		call	background_draw_laser
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		SCA_INFO_ENEMY_POWER3(ix)
		ld		a, #0
		jp		nz, enemy_boss8_center_s3_skip1	; Ep[c̏ȂƂP̂Ă skip1 
		inc		a
enemy_boss8_center_s3_skip1:
		ld		SCA_INFO_ENEMY_STATE_H3(ix), a
		ld		a, #CENTER_LASER_CYCLE
		ld		(wait_timer_laser), a
		ret

; -----------------------------------------------------------------------------
;	{X8̒eˏ
;		c	... ˍWX
;		b	...	ˍWY
;	output
;		Ȃ
;	break
;		a,b,d,e,f,h,l,ix,iy
; -----------------------------------------------------------------------------
enemy_boss8_shot:
		ld		a, (wait_timer_shot)
		dec		a
		ld		(wait_timer_shot), a
		ret		nz
		ld		a, #SHOT_CYCLE
		ld		(wait_timer_shot), a

enemy_boss8_shot2::
		push	bc
		call	enemy_shot_search
		pop		bc
		ret		z
		; ˂e̎ނ肷
		ld		a, (boss_shot_type)
		dec		a
		ld		(boss_shot_type), a
		jp		z, enemy_boss8_shot3

		; ]˂̏ꍇ
		push	bc
		push	hl
		; ˕]
		ld		hl, (boss_shot_angle)
		ld		de, #(512/11)
		add		hl, de
		ld		(boss_shot_angle), hl
		; sin, cos ߂
		call	enemy_get_cos
		ld		e, c
		ld		d, b
		pop		hl
		pop		bc
		jp		enemy_shot_start_one2

		; @Ə˂̏ꍇ
enemy_boss8_shot3:
		ld		a, #SHOT_TYPE_CHANGE
		ld		(boss_shot_type), a
		push	ix
		ld		ix, #boss_shot_info
		ld		iy, #player_info
		ld		SCA_INFO_XH(ix), c
		ld		SCA_INFO_YH(ix), b
		call	enemy_shot_start_one
		pop		ix
		ret

; -----------------------------------------------------------------------------
;	{X8̓oꏈ
;		iy	... G̃AhX
;	output
;		Ȃ
;	break
;		a,b,d,e,f,h,l,iy
; -----------------------------------------------------------------------------
enemy_boss8_start::
		; 蔻X{Xpɐ؂ւ
		ld		a, #2
		call	change_crash_check_routine
		; {XV[hXV
		ld		a, #32
		ld		SCA_INFO_ENEMY_POWER(iy), a		; p[c
		ld		SCA_INFO_ENEMY_POWER3(iy), a	; Ep[c
		ld		a, #80
		ld		SCA_INFO_ENEMY_POWER5(iy), a	; p[c
		; ԏ
		ld		a, #60
		ld		(wait_timer_left), a
		ld		(wait_timer_right), a
		ld		(wait_timer_center), a
		ld		a, #CENTER_LASER_CYCLE
		ld		(wait_timer_laser), a
		ld		a, #SHOT_CYCLE
		ld		(wait_timer_shot), a
		ld		a, #SHOT_TYPE_CHANGE
		ld		(boss_shot_type), a
		ld		hl, #0
		ld		(boss_shot_angle), hl
		xor		a
		ld		SCA_INFO_ENEMY_STATE_L(iy), a
		ld		SCA_INFO_ENEMY_STATE_L2(iy), a
		ld		SCA_INFO_ENEMY_STATE_H3(iy), a
		ld		a, #LEFT_PART_1ST_DOWN_TIME
		ld		SCA_INFO_ENEMY_STATE_H(iy), a
		ld		a, #RIGHT_PART_1ST_DOWN_TIME
		ld		SCA_INFO_ENEMY_STATE_H2(iy), a
		; X, YWXV (XvCgɉeoȂ悤 L gj
		ld		a, #1
		ld		SCA_INFO_XL(iy), a		; p[cX
		ld		a, #14
		ld		SCA_INFO_XL2(iy), a		; Ep[cX
		ld		a, #7
		ld		SCA_INFO_XL3(iy), a		; p[cX
		xor		a
		ld		SCA_INFO_YL(iy), a		; p[cY
		ld		SCA_INFO_YL2(iy), a		; Ep[cY
		ld		SCA_INFO_YL3(iy), a		; p[cY
		; {X\
		ld		e, SCA_INFO_XL(iy)
		ld		d, SCA_INFO_YL(iy)
		call	draw_boss8_left
		ld		e, SCA_INFO_XL2(iy)
		ld		d, SCA_INFO_YL2(iy)
		call	draw_boss8_right
		ld		e, SCA_INFO_XL3(iy)
		ld		d, SCA_INFO_YL3(iy)
		call	draw_boss8_center
		; YWXV
		ld		a, #212
		ld		SCA_INFO_YH(iy), a
		ld		SCA_INFO_YH2(iy), a
		ld		SCA_INFO_YH3(iy), a
		ld		SCA_INFO_YH4(iy), a
		ld		SCA_INFO_YH5(iy), a
		ld		SCA_INFO_YH6(iy), a
		ld		SCA_INFO_YH7(iy), a
		ld		SCA_INFO_YH8(iy), a
		; XWXV
		xor		a
		ld		SCA_INFO_XH(iy), a
		ld		SCA_INFO_XH2(iy), a
		ld		SCA_INFO_XH5(iy), a
		ld		SCA_INFO_XH6(iy), a
		ld		SCA_INFO_XH3(iy), a
		ld		SCA_INFO_XH4(iy), a
		ld		SCA_INFO_XH7(iy), a
		ld		SCA_INFO_XH8(iy), a
		ld		hl, #enemy_boss8_move
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		ld		hl, #enemy_boss8_move_dummy
		ld		de, #SCA_INFO_SIZE * 2
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		ret

wait_timer_left:
		.db		#0
wait_timer_right:
		.db		#0
wait_timer_center:
		.db		#0
wait_timer_laser:
		.db		#0
boss_center_update::
		.db		#0
wait_timer_shot:
		.db		#0
boss_shot_angle:
		.dw		#0
boss_shot_type:
		.db		#0
boss_shot_info:
		.ds		4
