; -----------------------------------------------------------------------------
;	XvCg\XV
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.globl		player_invincibility
		.globl		software_timer

		.area	CODE (ABS)

; -----------------------------------------------------------------------------
;	DRAM̃XvCgAgr[ge[uC[W
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		a,b,c,d,e,f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_init::
		; XvCgAgr[ge[u 212 ŏ
		ld		hl, #sprite_attribute_table
		ld		de, #(sprite_attribute_table + 1)
		ld		bc, #(4*32 - 1)
		ld		(hl), #212
		ldir
		; XvCgp^[ԍ
		ld		b, #32
		ld		de, #sprite_pattern_data
		ld		hl, #(sprite_attribute_table + 2)
sprite_init_loop1:
		ld		a, (de)
		ld		(hl), a
		inc		de
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		djnz	sprite_init_loop1
		ret

; -----------------------------------------------------------------------------
;	XvCgJ[Zbg
;	input
;		a ...	XvCgԍ(0`31)
;		c ...	Ff[^
;	output
;		Ȃ
;	break
;		S
;	comment
;		COLOR SPRITE(a) = c ɑ
; -----------------------------------------------------------------------------
sprite_set_color::
		; hl = SPRITE_COLOR + a * 16
		ld		hl, #SPRITE_COLOR
		rlca			; ctO͕K 0
		rlca			; ctO͕K 0
		rlca			; ctO͕K 0
		rlca
		jr		nc, sprite_set_color_skip1
		inc		h
sprite_set_color_skip1:
		ld		l, a	; SPRITE_COLOR ̉8bit  0x00 Ȃ̂ a+l  a ƓBȂ̂őŗǂB
		; a = Ff[^
		ld		a, c
		; bc = 16
		ld		bc, #16
		jp		FILVRM

; -----------------------------------------------------------------------------
;	DRAM̃XvCgAgr[ge[uC[WXV
;	input:
;		ix	...	e[ũAhX
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_update::
		; e[u̍WDRAM̃Agr[ge[uC[W֓]
		ld		de, #SCA_INFO_SIZE
		ld		hl, #sprite_attribute_table
		ld		b, #32
sprite_update_loop:
		ld		a, SCA_INFO_YH(ix)
		ld		(hl), a
		inc		hl
		ld		a, SCA_INFO_XH(ix)
		ld		(hl), a
		inc		hl
		inc		hl
		inc		hl
		add		ix, de
		djnz	sprite_update_loop
sprite_update_player:
		; @GԂH
		ld		a, (player_invincibility)
		or		a
		jr		z, sprite_update_transfer
		inc		a
		jr		z, sprite_update_transfer
		; 1/30̃^C~OH
		ld		a, (software_timer)
		and		#1
		jr		z, sprite_update_transfer
		; @\ɂi_łj
		ld		a, #212
		ld		(sprite_attribute_table + 0), a
		ld		(sprite_attribute_table + 4), a
sprite_update_transfer:
		; Agr[ge[uC[WVRAM֓]
		ld		hl, #sprite_attribute_table
		ld		de, #SPRITE_ATTRIBUTE
		ld		bc, #(4*32)
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	XvCgS
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_all_clear::
		ld		b, #32
		ld		hl, #sprite_attribute_table
		ld		a, #212
sprite_all_clear_loop:
		ld		(hl), a
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		djnz	sprite_all_clear_loop
		jp		sprite_update_transfer

sprite_attribute_table::
		.ds		4*32				; (+0:YW, +1:XW, +2:p^[ԍ, +3:gp)  32

sprite_pattern_data:
		.db		#0 , #4 , #12, #16, #24, #28, #32, #36
		.db		#40, #44, #48, #52, #56, #60, #20, #20
		.db		#20, #20, #20, #20, #20, #20, #20, #20
		.db		#20, #20, #20, #20, #20, #8 , #8 , #8 
